# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class NodeDriveconfigNodeReboot(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        NodeDriveconfigNodeReboot - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'chassis_loss': 'bool',
            'none_present': 'bool'
        }

        self.attribute_map = {
            'chassis_loss': 'chassis_loss',
            'none_present': 'none_present'
        }

        self._chassis_loss = True
        self._none_present = True

    @property
    def chassis_loss(self):
        """
        Gets the chassis_loss of this NodeDriveconfigNodeReboot.
        Indicates whether or not to reboot the node due to a lost chassis.

        :return: The chassis_loss of this NodeDriveconfigNodeReboot.
        :rtype: bool
        """
        return self._chassis_loss

    @chassis_loss.setter
    def chassis_loss(self, chassis_loss):
        """
        Sets the chassis_loss of this NodeDriveconfigNodeReboot.
        Indicates whether or not to reboot the node due to a lost chassis.

        :param chassis_loss: The chassis_loss of this NodeDriveconfigNodeReboot.
        :type: bool
        """
        
        self._chassis_loss = chassis_loss

    @property
    def none_present(self):
        """
        Gets the none_present of this NodeDriveconfigNodeReboot.
        Indicates whether or not to reboot the node if no drives are present.

        :return: The none_present of this NodeDriveconfigNodeReboot.
        :rtype: bool
        """
        return self._none_present

    @none_present.setter
    def none_present(self, none_present):
        """
        Sets the none_present of this NodeDriveconfigNodeReboot.
        Indicates whether or not to reboot the node if no drives are present.

        :param none_present: The none_present of this NodeDriveconfigNodeReboot.
        :type: bool
        """
        
        self._none_present = none_present

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

