# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class NodeDriveconfigNodeSpinWait(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        NodeDriveconfigNodeSpinWait - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'check_drive': 'int',
            'stagger': 'int'
        }

        self.attribute_map = {
            'check_drive': 'check_drive',
            'stagger': 'stagger'
        }

        self._check_drive = None
        self._stagger = None

    @property
    def check_drive(self):
        """
        Gets the check_drive of this NodeDriveconfigNodeSpinWait.
        Seconds to wait between enabling a bay and checking for an inserted drive.

        :return: The check_drive of this NodeDriveconfigNodeSpinWait.
        :rtype: int
        """
        return self._check_drive

    @check_drive.setter
    def check_drive(self, check_drive):
        """
        Sets the check_drive of this NodeDriveconfigNodeSpinWait.
        Seconds to wait between enabling a bay and checking for an inserted drive.

        :param check_drive: The check_drive of this NodeDriveconfigNodeSpinWait.
        :type: int
        """
        
        if check_drive is not None  and check_drive > 4.294967295E9:
            raise ValueError("Invalid value for `check_drive`, must be a value less than or equal to `4.294967295E9`")

        self._check_drive = check_drive

    @property
    def stagger(self):
        """
        Gets the stagger of this NodeDriveconfigNodeSpinWait.
        Seconds to wait between enabling a bay and enabling another bay.

        :return: The stagger of this NodeDriveconfigNodeSpinWait.
        :rtype: int
        """
        return self._stagger

    @stagger.setter
    def stagger(self, stagger):
        """
        Sets the stagger of this NodeDriveconfigNodeSpinWait.
        Seconds to wait between enabling a bay and enabling another bay.

        :param stagger: The stagger of this NodeDriveconfigNodeSpinWait.
        :type: int
        """
        
        if stagger is not None  and stagger > 4.294967295E9:
            raise ValueError("Invalid value for `stagger`, must be a value less than or equal to `4.294967295E9`")

        self._stagger = stagger

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

